package com.e1c.test;

import org.moe.natj.general.Pointer;
import org.moe.natj.general.ann.RegisterOnStartup;
import org.moe.natj.objc.ann.Selector;

import apple.NSObject;
import apple.foundation.NSDictionary;
import apple.uikit.UIApplication;
import apple.uikit.UIWindow;
import apple.uikit.c.UIKit;
import apple.uikit.protocol.UIApplicationDelegate;

import com.e1c.test.kv.IKVDatabase;
import com.e1c.test.sqlite.SQLiteKVDatabase;

@RegisterOnStartup
public class Main extends NSObject implements UIApplicationDelegate
{

    public static void main(String[] args)
    {
        UIKit.UIApplicationMain(0, null, null, Main.class.getName());
    }

    @Selector("alloc")
    public static native Main alloc();

    protected Main(Pointer peer)
    {
        super(peer);

        IKVDatabase objectMetadataStore = SQLiteKVDatabase.openOrCreate("ObjectMetadata", 100);
    }

    private UIWindow window;

    @Override
    public boolean applicationDidFinishLaunchingWithOptions(UIApplication application, NSDictionary launchOptions)
    {
        return true;
    }

    @Override
    public void setWindow(UIWindow value)
    {
        window = value;
    }

    @Override
    public UIWindow window()
    {
        return window;
    }
}
