/*
 * Copyright (C) 2017, 1C
 */

package com.e1c.test.sqlite;


import com.e1c.test.kv.IKVReadTransaction;
import com.e1c.test.kv.IKVSequence;
import com.e1c.test.kv.IKVWriteTransaction;
import com.e1c.test.utils.ByteString;

import static com.google.common.base.Preconditions.checkArgument;


final class SQLiteKeyValueStore implements AutoCloseable, IKVReadTransaction, IKVWriteTransaction
{
    public static final String TABLE_NAME = "key_value";
    private static final String putSql = "INSERT OR REPLACE INTO key_value (k, v) VALUES (?, ?);";
    private static final String deleteSql = "DELETE FROM key_value WHERE k = ?;";
    private static final String getSql = "SELECT k,v FROM key_value WHERE k = ?;";
    private static final String iterateFromStartSql = "SELECT k,v FROM key_value ORDER BY k LIMIT ? OFFSET ?;";
    private static final String iterateFromKeySql = "SELECT k,v FROM key_value WHERE k >= ? ORDER BY k LIMIT ? OFFSET ?;";

    private final int pageSize;

    public static SQLiteKeyValueStore openForRead(String databaseName, int pageSize)
    {
        checkArgument(databaseName != null && !databaseName.isEmpty(), "Database name should not be null or empty.");

        return new SQLiteKeyValueStore(pageSize);
    }

    public static SQLiteKeyValueStore openForWrite(String databaseName, int pageSize)
    {
        checkArgument(databaseName != null && !databaseName.isEmpty(), "Database name should not be null or empty.");

        return new SQLiteKeyValueStore(pageSize);
    }

    private SQLiteKeyValueStore(int pageSize)
    {
        this.pageSize = pageSize;
    }

    @Override
    public void close()
    {
    }

    public void put(ByteString key, ByteString value)
    {
    }

    public void delete(ByteString key)
    {
    }

    public ByteString get(ByteString key)
    {
        return null;
    }

    @Override
    public IKVSequence sequence()
    {
        return new SQLiteSequence(this, false);
    }

    @Override
    public void commit()
    {
    }

    public int getPageSize()
    {
        return pageSize;
    }
}
