/*
 * Copyright (C) 2017, 1C
 */

package com.e1c.test.utils;

import java.nio.charset.Charset;

/**
 *
 * The classes contained within are used internally by the Protocol Buffer
 * library and generated message implementations. They are public only because
 * those generated messages do not reside in the {@code protobuf} package.
 * Others should not use this class directly.
 *
 * @author kenton@google.com (Kenton Varda)
 */
final class Internal
{

    private Internal()
    {
    }

    static final Charset UTF_8 = Charset.forName("UTF-8");

    /**
     * Helper method for continuously hashing bytes.
     */
    static int partialHash(int h, byte[] bytes, int offset, int length) {
        for (int i = offset; i < offset + length; i++) {
            h = h * 31 + bytes[i];
        }
        return h;
    }

    /**
     * An empty byte array constant used in generated code.
     */
    public static final byte[] EMPTY_BYTE_ARRAY = new byte[0];
}
